/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cviceni02;

/**
 *
 * @author Kuba
 */
public class SpojovySeznam {
    Prvek zacatek;
    Prvek konec;

    SpojovySeznam(){
        zacatek = null;
        konec = null;
    }

    void pridejNaZacatek(int h){
        Prvek novy = new Prvek(h);
        novy.nasl = zacatek;
        novy.pred = null;
        if(zacatek != null)
            zacatek.pred = novy;
        zacatek = novy;
        if(konec == null)
            konec = novy;
    }

    void pridejNaKonec(int h){
        Prvek novy = new Prvek(h);
        novy.nasl = null;
        novy.pred = konec;
        if(konec != null)
            konec.nasl = novy;
        konec = novy;
        if(zacatek == null)
            zacatek = novy;
    }

    void odeberZKonce(){
        if(konec != null){
            if(konec.pred != null){
                konec = konec.pred;
                konec.nasl = null;
            }
            else{
                konec = null;
                zacatek = null;
            }
        }
    }

    void odeberZeZacatku(){
        if(zacatek != null){
            if(zacatek.nasl != null){
                zacatek = zacatek.nasl;
                zacatek.pred = null;
            }
            else{
                zacatek = null;
                konec = null;
            }
        }
    }

    void odeberPodleIndexu(int n){
        //--- Najdi prvek s indexem 'n'
        int i = 0;
        Prvek pom = zacatek;
        while((i < n) && (pom != null)){
            pom = pom.nasl;
            i++;
        }

        //--- Existuje n-ty prvek nebo ne?
        if(pom == null){
            System.out.println("V seznamu neni prvek s indexem " + n + " (cilsovano od 0)");
            return;
        }

        //--- Odstran prvek, na ktery ukazuje "pom"
        if(pom.pred != null)
            (pom.pred).nasl = pom.nasl;
        if(pom.nasl != null)
            (pom.nasl).pred = pom.pred;
    }

    void vypisSeznam(String hlaska){
        System.out.print(hlaska);
        Prvek p = zacatek;
        while(p != null){
            System.out.print(" " + p.hodnota);
            p = p.nasl;
            if(p != null)
                System.out.print(",");
            else
                System.out.println("");
        }
    }

    public static void main(String[] args) {
        //--- Inicializuj seznam
        SpojovySeznam sz = new SpojovySeznam();

        //--- Pridej prvky do seznamu: { 6 5 4 1 2 3 }
        sz.pridejNaZacatek(4);
        sz.pridejNaZacatek(5);
        sz.pridejNaZacatek(6);
        sz.pridejNaKonec(1);
        sz.pridejNaKonec(2);
        sz.pridejNaKonec(3);
        sz.vypisSeznam("Puvodni seznam:");

        //--- Odeber prvky ze seznamu
        sz.odeberZKonce();
        sz.odeberZeZacatku();
        sz.odeberPodleIndexu(2);

        sz.vypisSeznam("Vysledny seznam:");
    }
}

class Prvek{
    int hodnota;
    Prvek pred; // predchudce
    Prvek nasl; // naslednik

    Prvek(int h){
        hodnota = h;
    }
}
